<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="fr"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>GpsUtilService.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">TourGuide</a> &gt; <a href="index.source.html" class="el_package">tourGuide.service</a> &gt; <span class="el_source">GpsUtilService.java</span></div><h1>GpsUtilService.java</h1><pre class="source lang-java linenums">package tourGuide.service;

import com.google.common.util.concurrent.RateLimiter;
import gpsUtil.GpsUtil;
import gpsUtil.location.Attraction;
import gpsUtil.location.Location;
import gpsUtil.location.VisitedLocation;
import org.springframework.stereotype.Service;
import tourGuide.user.User;

import java.util.Date;
import java.util.List;
import java.util.UUID;
import java.util.concurrent.*;

@Service
public class GpsUtilService {
    private final GpsUtil gpsUtil;
<span class="fc" id="L19">    private ExecutorService service = Executors.newFixedThreadPool(100000);</span>

<span class="fc" id="L21">    public GpsUtilService(GpsUtil gpsUtil) {</span>
<span class="fc" id="L22">        this.gpsUtil = gpsUtil;</span>
<span class="fc" id="L23">    }</span>


    public VisitedLocation getUserLocation(UUID userId) {
<span class="fc" id="L27">        this.sleep();</span>
<span class="fc" id="L28">        double longitude = ThreadLocalRandom.current().nextDouble(-180.0D, 180.0D);</span>
<span class="fc" id="L29">        double latitude = ThreadLocalRandom.current().nextDouble(-85.05112878D, 85.05112878D);</span>
<span class="fc" id="L30">        return new VisitedLocation(userId, new Location(latitude, longitude), new Date());</span>
    }

    private void sleep() {
<span class="fc" id="L34">        int random = ThreadLocalRandom.current().nextInt(30, 100);</span>

        try {
<span class="fc" id="L37">            TimeUnit.MILLISECONDS.sleep((long)random);</span>
<span class="nc" id="L38">        } catch (InterruptedException var3) {</span>
<span class="fc" id="L39">        }</span>

<span class="fc" id="L41">    }</span>

    public void addUserLocation(User user, RewardsService rewardsService) {
<span class="fc" id="L44">            CompletableFuture.supplyAsync(() -&gt; getUserLocation(user.getUserId()), service)</span>
<span class="fc" id="L45">                        .thenAccept(user::addToVisitedLocations)</span>
<span class="fc" id="L46">                    .thenRun(() -&gt; rewardsService.calculateRewards(user));</span>
<span class="fc" id="L47">    }</span>

    public List&lt;Attraction&gt; getAttractions() {
<span class="fc" id="L50">        return gpsUtil.getAttractions();</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>